/**
 * @file support js stat
 */



var BaiduMobStat = (function () {

    var version = (function () {
      var u = window.navigator.userAgent
      return {// 移动终端浏览器版本信息
        trident: u.indexOf('Trident') > -1, // IE内核
        presto: u.indexOf('Presto') > -1, // opera内核
        webKit: u.indexOf('AppleWebKit') > -1, // 苹果、谷歌内核
        gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') === -1, // 火狐内核
        mobile: !!u.match(/AppleWebKit.*Mobile/i) || !!u.match(/MIDP|SymbianOS|NOKIA|SAMSUNG|LG|NEC|TCL|Alcatel|BIRD|DBTEL|Dopod|PHILIPS|HAIER|LENOVO|MOT-|Nokia|SonyEricsson|SIE-|Amoi|ZTE/), // 是否为移动终端
        ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), // ios终端
        android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, // android终端或者uc浏览器
        iPhone: u.indexOf('iPhone') > -1 || u.indexOf('Mac') > -1, // 是否为iPhone或者QQHD浏览器
        iPad: u.indexOf('iPad') > -1, // 是否iPad
        webApp: u.indexOf('Safari') === -1 // 是否web应该程序，没有头部与底部
      }
    }())

    var invokeNatvieMethod;

    if(version.ios)
      invokeNatvieMethod = function(action, obj) {
      window.webkit.messageHandlers.bmtj.postMessage({action:action, obj: obj});
    }

    else
      invokeNatvieMethod = function (action, obj) {
        console.info('invokeNatvieMethod',action,obj);

        // call native method
        var cmd = {
            action: action,
            obj: obj
        };

        var iFrame = document.createElement('iframe');
        iFrame.setAttribute('src', 'bmtj:' + encodeURIComponent(JSON.stringify(cmd)));
        iFrame.setAttribute('style', 'display:none;');
        iFrame.setAttribute('height', '0px');
        iFrame.setAttribute('width', '0px');
        iFrame.setAttribute('frameborder', '0');

        document.body.appendChild(iFrame);

        // 发起请求后这个iFrame就没用了，所以把它从dom上移除掉
        iFrame.parentNode.removeChild(iFrame);
        iFrame = null;
    };

    return {
        onPageStart: function (page) {
            var obj = {
                'page': page
            };

            invokeNatvieMethod('onPageStart', obj);
        },
        onPageEnd: function (page) {
            var obj = {
                'page': page
            };

            invokeNatvieMethod('onPageEnd', obj);
        },
        onEvent: function (id, label, acc) {
            var obj = {
                'event_id': id,
                'label': label,
                'acc': typeof acc === 'number' ? acc : 1
            };
            console.log(1,obj)
            invokeNatvieMethod('onEvent', obj);
        },
        onEventStart: function (id, label) {
            var obj = {
                'event_id': id,
                'label': label
            };
          console.log(2,obj)
            invokeNatvieMethod('onEventStart', obj);
        },
        onEventEnd: function (id, label) {
            var obj = {
                'event_id': id,
                'label': label
            };
          console.log(3,obj)
            invokeNatvieMethod('onEventEnd', obj);
        },
        onEventDuration: function (id, label, duration) {
            var obj = {
                'event_id': id,
                'label': label,
                'duration': typeof duration === 'number' ? duration : -1
            };

            invokeNatvieMethod('onEventDuration', obj);
        },
        onEventWithAttributes: function (id, label, acc, attributes) {
            var obj = {
                'event_id': id,
                'label': label,
                'acc': typeof acc === 'number' ? acc : 1,
                'attributes': typeof attributes === 'object' ? attributes : {}
            };

            invokeNatvieMethod('onEvent', obj);
        },
        onEventEndWithAttributes: function (id, label, attributes) {
            var obj = {
                'event_id': id,
                'label': label,
                'attributes': typeof attributes === 'object' ? attributes : {}
            };

            invokeNatvieMethod('onEventEnd', obj);
        },
        onEventDurationWithAttributes: function (id, label, duration, attributes) {
            var obj = {
                'event_id': id,
                'label': label,
                'duration': typeof duration === 'number' ? duration : 0,
                'attributes': typeof attributes === 'object' ? attributes : {}
            };

            invokeNatvieMethod('onEventDuration', obj);
        }
    };
}());
